# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['hack_chatgpt', 'hack_chatgpt.client', 'hack_chatgpt.generated.proto']

package_data = \
{'': ['*']}

install_requires = \
['flask_restx>=1.0.0',
 'grpcio-health-checking>=1.50.0',
 'grpcio-tools>=1.50.0',
 'grpcio>=1.50.0',
 'jinja2>=2.0',
 'jsonref>=1.0.0',
 'plumbum>=1.7.0',
 'protobuf>=4.21',
 'pydantic>=1.8']

setup_kwargs = {
    'name': 'hack-chatgpt',
    'version': '0.1.1',
    'description': '',
    'long_description': '# A python client and wrapper for nodejs chatgpt_api\n\n\n## demo \n```bash\nPlease write your questions... \n什么是爱？\nAnswer: 爱是一种情感，它是人类之间最强烈的情感之一。它可以是指对另一个人的感情，也可以是指对某种事物的喜爱。爱可以是非常强烈和深深的，也可以是轻微的。爱通常是由一系列的情感、思想和行为组成的，包括热爱、喜爱、尊敬、关心、信任和自我牺牲。爱也可以被看作是对他人的慈爱和照顾，并表现出对他人的关怀和付出。\nPlease write your questions... \n可以详细一点吗？\nAnswer: 当人们说他们爱某人时，通常是指他们对对方有强烈的情感，并希望与对方保持联系。这种爱可能是指爱情，也可能是指友谊、亲情或父母对子女的爱。爱情是一种强烈的情感，它源自人类的生理需求和心理需求，常常伴随着强烈的情感和情绪。爱情通常是由彼此间的信任、尊重、理解和支持所构成的。\n\n友谊是一种积极的情感关系，其基础是友好和尊重。友谊可以是两个人之间的关系，也可以是一群人之间的关系。友谊是人与人之间最重要的情感关系之一，因为它能够给人带来支持、理解、安慰和慰藉。\n\n亲情是指家庭成员之间的情感关系，包括父母对子女的爱和子女对父母的爱。亲情是一种深厚而牢固的情感关系，它源自于共同的血缘关系和共同的文化背景。亲情是人类最基本的情感关系之一，它给人带来温暖、安全感和保护感。\nPlease write your questions... \n我还是不是特别理解,可以举个例子吗？\nAnswer: 当一个人对另一个人有爱意时，他们可能会表现出许多不同的情感、思想和行为。例如，他们可能会：\n\n- 对对方充满热爱和喜爱，希望与对方保持密切的联系。\n- 尊敬对方，尊重对方的感受和想法。\n- 关心对方的健康和幸福，希望对方能够感到安全和舒适。\n- 信任对方，相信对方会对自己做出正确的决定。\n- 牺牲自己的利益，为了让对方感到幸福而付出努力。\n\n这些情感、思想和行为可以通过许多不同的方式表现出来，例如通过言语、行动、身体语言或表情。\n\n例如，一个人可能会告诉他所爱的人，“我爱你”，或者通过触摸、拥抱、亲吻或牵手来表达他的爱意。他也可能会为对方做一些小心意，例如帮对方买早餐或者替对方做一些家务。这些举动都表明了他对对方有爱意，并希望能够与对方保持亲密的关系。\nPlease write your questions... \n```\n## usage\n* first run a chatgpt-api grpc server\n\n```bash\nnpm install\nnpx tsx server/index.ts  \n```\n\n* then using python\n\n```python\n#!/usr/bin/env python\n# coding:utf-8\n""" \n@author: nivic ybyang7\n@license: Apache Licence \n@file: client\n@time: 2022/12/24\n@contact: ybyang7@iflytek.com\n@site:  \n@software: PyCharm \n\n# code is far away from bugs with the god animal protecting\n    I love animals. They taste delicious.\n              ┏┓      ┏┓\n            ┏┛┻━━━┛┻┓\n            ┃      ☃      ┃\n            ┃  ┳┛  ┗┳  ┃\n            ┃      ┻      ┃\n            ┗━┓      ┏━┛\n                ┃      ┗━━━┓\n                ┃  神兽保佑    ┣┓\n                ┃\u3000永无BUG！   ┏┛\n                ┗┓┓┏━┳┓┏┛\n                  ┃┫┫  ┃┫┫\n                  ┗┻┛  ┗┻┛ \n"""\n\n#  Copyright (c) 2022. Lorem ipsum dolor sit amet, consectetur adipiscing elit.\n#  Morbi non lorem porttitor neque feugiat blandit. Ut vitae ipsum eget quam lacinia accumsan.\n#  Etiam sed turpis ac ipsum condimentum fringilla. Maecenas magna.\n#  Proin dapibus sapien vel ante. Aliquam erat volutpat. Pellentesque sagittis ligula eget metus.\n#  Vestibulum commodo. Ut rhoncus gravida arcu.\n\n\nfrom hack_chatgpt.generated.proto import chatgpt_pb2\nfrom hack_chatgpt.generated.proto.chatgpt_pb2_grpc import *\n\nimport grpc\n\nimport sys\nimport signal\n\n\ndef quit(signum, frame):\n    sys.exit()\n\n\nclass ChatGptClient():\n    def __init__(self, email, password, proxyServer, isGoogleLogin=True, grpc_addr="localhost:8080"):\n        self.server = grpc_addr\n        self.channel = grpc.insecure_channel(self.server)\n        self.stub = ChatGptProxyServerStub(self.channel)\n        resp = self.stub.InitSession(\n            chatgpt_pb2.InitSessionRequest(isGoogleLogin=isGoogleLogin, email=email, password=password,\n                                           proxyServer=proxyServer))\n        self.conversationId = ""\n        self.messageId = ""\n\n    def send(self, message):\n        resp = self.stub.SendMessage(\n            chatgpt_pb2.Message(content=message, conversationId=self.conversationId, messageId=self.messageId))\n        print(resp.content)\n        self.conversationId = resp.conversationId\n        self.messageId = resp.messageId\n\n    def exec(self):\n        # Set an initial condition.\n        game_active = True\n        signal.signal(signal.SIGHUP, quit)\n        signal.signal(signal.SIGTERM, quit)\n        # Set up the while loop.\n        while game_active:\n            message = input("Please write your questions... \\n")\n            resp = self.stub.SendMessage(\n                chatgpt_pb2.Message(content=message, conversationId=self.conversationId, messageId=self.messageId))\n            print("Answer: " + resp.content)\n            self.conversationId = resp.conversationId\n            self.messageId = resp.messageId\n\n\nif __name__ == \'__main__\':\n    c = ChatGptClient(email="xxx@gmail.com", password="xxxx", isGoogleLogin=True,\n                      proxyServer="localhost:7890")\n    c.exec()\n\n```\n\n## architecture\n\nthanks for the [project](https://github.com/transitive-bullshit/chatgpt-api)\n\ni wrote a grpc server according to the [chatgpt-api](https://github.com/transitive-bullshit/chatgpt-api)\n\n## roadmap\n\n✅ support google account autologin\n\n✅ support at least one account online\n\n✅ support simple client using python\n\n✅ support exec using python\n\n\n❌ support microsoft account autologin\n\n❌ support docker deploy nodejs\n\n❌ support distribute deploy',
    'author': 'ybyang',
    'author_email': 'ybyang7@iflytek.com',
    'maintainer': None,
    'maintainer_email': None,
    'url': None,
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.7,<4.0',
}


setup(**setup_kwargs)
